Merge branch '20688-wb1-to-wb2-redirects' refs #20688
[arvados.git] / tools / salt-install / installer.sh
1 #!/bin/bash
2
3 # Copyright (C) The Arvados Authors. All rights reserved.
4 #
5 # SPDX-License-Identifier: CC-BY-SA-3.0
6
7 #
8 # installer.sh
9 #
10 # Helps manage the configuration in a git repository, and then deploy
11 # nodes by pushing a copy of the git repository to each node and
12 # running the provision script to do the actual installation and
13 # configuration.
14 #
15
16 set -eu
17 set -o pipefail
18
19 # The parameter file
20 declare CONFIG_FILE=local.params
21
22 # The salt template directory
23 declare CONFIG_DIR=local_config_dir
24
25 # The 5-character Arvados cluster id
26 # This will be populated by loadconfig()
27 declare CLUSTER
28
29 # The parent domain (not including the cluster id)
30 # This will be populated by loadconfig()
31 declare DOMAIN
32
33 # A bash associative array listing each node and mapping to the roles
34 # that should be provisioned on those nodes.
35 # This will be populated by loadconfig()
36 declare -A NODES
37
38 # A bash associative array listing each role and mapping to the nodes
39 # that should be provisioned with this role.
40 # This will be populated by loadconfig()
41 declare -A ROLE2NODES
42
43 # The ssh user we'll use
44 # This will be populated by loadconfig()
45 declare DEPLOY_USER
46
47 # The git repository that we'll push to on all the nodes
48 # This will be populated by loadconfig()
49 declare GITTARGET
50
51 # The public host used as an SSH jump host
52 # This will be populated by loadconfig()
53 declare USE_SSH_JUMPHOST
54
55 # The temp file that will get used to disable envvar forwarding to avoid locale
56 # issues in Debian distros.
57 # This will be populated by loadconfig()
58 declare SSH_CONFFILE
59
60 checktools() {
61     local MISSING=''
62     for a in git ip ; do
63         if ! which $a ; then
64             MISSING="$MISSING $a"
65         fi
66     done
67     if [[ -n "$MISSING" ]] ; then
68         echo "Some tools are missing, please make sure you have the 'git' and 'iproute2' packages installed"
69         exit 1
70     fi
71 }
72
73 cleanup() {
74     local NODE=$1
75     local SSH=`ssh_cmd "$NODE"`
76     # Delete the old repository
77     $SSH $DEPLOY_USER@$NODE rm -rf ${GITTARGET}.git ${GITTARGET}
78 }
79
80 sync() {
81     local NODE=$1
82     local BRANCH=$2
83
84     # Synchronizes the configuration by creating a git repository on
85     # each node, pushing our branch, and updating the checkout.
86
87     if [[ "$NODE" != localhost ]] ; then
88         SSH=`ssh_cmd "$NODE"`
89         GIT="eval `git_cmd $NODE`"
90
91         cleanup $NODE
92
93         # Update the git remote for the remote repository.
94         if ! $GIT remote add $NODE $DEPLOY_USER@$NODE:${GITTARGET}.git ; then
95             $GIT remote set-url $NODE $DEPLOY_USER@$NODE:${GITTARGET}.git
96         fi
97
98         # Initialize the git repository.  We're
99         # actually going to make two repositories here because git
100         # will complain if you try to push to a repository with a
101         # checkout. So we're going to create a "bare" repository
102         # and then clone a regular repository (with a checkout)
103         # from that.
104
105         $SSH $DEPLOY_USER@$NODE git init --bare --shared=0600 ${GITTARGET}.git
106         $GIT push $NODE $BRANCH
107         $SSH $DEPLOY_USER@$NODE "umask 0077 && git clone -s ${GITTARGET}.git ${GITTARGET} && git -C ${GITTARGET} checkout ${BRANCH}"
108     fi
109 }
110
111 deploynode() {
112     local NODE=$1
113     local ROLES=$2
114     local BRANCH=$3
115
116     # Deploy a node.  This runs the provision script on the node, with
117     # the appropriate roles.
118
119     sync $NODE $BRANCH
120
121     if [[ -z "$ROLES" ]] ; then
122                 echo "No roles specified for $NODE, will deploy all roles"
123     else
124                 ROLES="--roles ${ROLES}"
125     fi
126
127     logfile=deploy-${NODE}-$(date -Iseconds).log
128     SSH=`ssh_cmd "$NODE"`
129
130     if [[ "$NODE" = localhost ]] ; then
131             SUDO=''
132                 if [[ $(whoami) != 'root' ]] ; then
133                         SUDO=sudo
134                 fi
135                 $SUDO ./provision.sh --config ${CONFIG_FILE} ${ROLES} 2>&1 | tee $logfile
136     else
137             $SSH $DEPLOY_USER@$NODE "cd ${GITTARGET} && git log -n1 HEAD && DISABLED_CONTROLLER=\"$DISABLED_CONTROLLER\" sudo --preserve-env=DISABLED_CONTROLLER ./provision.sh --config ${CONFIG_FILE} ${ROLES}" 2>&1 | tee $logfile
138             cleanup $NODE
139     fi
140 }
141
142 loadconfig() {
143     if ! [[ -s ${CONFIG_FILE} && -s ${CONFIG_FILE}.secrets ]]; then
144                 echo "Must be run from initialized setup dir, maybe you need to 'initialize' first?"
145     fi
146     source common.sh
147     GITTARGET=arvados-deploy-config-${CLUSTER}
148
149         # Set up SSH so that it doesn't forward any environment variable. This is to avoid
150         # getting "setlocale" errors on the first run, depending on the distro being used
151         # to run the installer (like Debian).
152         SSH_CONFFILE=$(mktemp)
153         echo "Include config SendEnv -*" > ${SSH_CONFFILE}
154 }
155
156 ssh_cmd() {
157         local NODE=$1
158         if [ -z "${USE_SSH_JUMPHOST}" -o "${NODE}" == "${USE_SSH_JUMPHOST}" -o "${NODE}" == "localhost" ]; then
159                 echo "ssh -F ${SSH_CONFFILE}"
160         else
161                 echo "ssh -F ${SSH_CONFFILE} -J ${DEPLOY_USER}@${USE_SSH_JUMPHOST}"
162         fi
163 }
164
165 git_cmd() {
166         local NODE=$1
167         echo "GIT_SSH_COMMAND=\"`ssh_cmd ${NODE}`\" git"
168 }
169
170 set +u
171 subcmd="$1"
172 set -u
173
174 if [[ -n "$subcmd" ]] ; then
175     shift
176 fi
177 case "$subcmd" in
178     initialize)
179         if [[ ! -f provision.sh ]] ; then
180             echo "Must be run from arvados/tools/salt-install"
181             exit
182         fi
183
184         checktools
185
186         set +u
187         SETUPDIR=$1
188         PARAMS=$2
189         SLS=$3
190         TERRAFORM=$4
191         set -u
192
193         err=
194         if [[ -z "$PARAMS" || ! -f local.params.example.$PARAMS ]] ; then
195             echo "Not found: local.params.example.$PARAMS"
196             echo "Expected one of multiple_hosts, single_host_multiple_hostnames, single_host_single_hostname"
197             err=1
198         fi
199
200         if [[ -z "$SLS" || ! -d config_examples/$SLS ]] ; then
201             echo "Not found: config_examples/$SLS"
202             echo "Expected one of multi_host/aws, single_host/multiple_hostnames, single_host/single_hostname"
203             err=1
204         fi
205
206         if [[ -z "$SETUPDIR" || -z "$PARAMS" || -z "$SLS" ]]; then
207             echo "installer.sh <setup dir to initialize> <params template> <config template>"
208             err=1
209         fi
210
211         if [[ -n "$err" ]] ; then
212             exit 1
213         fi
214
215         echo "Initializing $SETUPDIR"
216         git init --shared=0600 $SETUPDIR
217         cp -r *.sh tests $SETUPDIR
218
219         cp local.params.example.$PARAMS $SETUPDIR/${CONFIG_FILE}
220         cp local.params.secrets.example $SETUPDIR/${CONFIG_FILE}.secrets
221         cp -r config_examples/$SLS $SETUPDIR/${CONFIG_DIR}
222
223         if [[ -n "$TERRAFORM" ]] ; then
224             mkdir $SETUPDIR/terraform
225             cp -r $TERRAFORM/* $SETUPDIR/terraform/
226         fi
227
228         cd $SETUPDIR
229         echo '*.log' > .gitignore
230         echo '**/.terraform' >> .gitignore
231         echo '**/.infracost' >> .gitignore
232
233         if [[ -n "$TERRAFORM" ]] ; then
234                 git add terraform
235         fi
236
237         git add *.sh ${CONFIG_FILE} ${CONFIG_FILE}.secrets ${CONFIG_DIR} tests .gitignore
238         git commit -m"initial commit"
239
240         echo
241         echo "Setup directory $SETUPDIR initialized."
242         if [[ -n "$TERRAFORM" ]] ; then
243             (cd $SETUPDIR/terraform/vpc && terraform init)
244             (cd $SETUPDIR/terraform/data-storage && terraform init)
245             (cd $SETUPDIR/terraform/services && terraform init)
246             echo "Now go to $SETUPDIR, customize 'terraform/vpc/terraform.tfvars' as needed, then run 'installer.sh terraform'"
247         else
248                 echo "Now go to $SETUPDIR, customize '${CONFIG_FILE}', '${CONFIG_FILE}.secrets' and '${CONFIG_DIR}' as needed, then run 'installer.sh deploy'"
249         fi
250         ;;
251
252     terraform)
253         logfile=terraform-$(date -Iseconds).log
254         (cd terraform/vpc && terraform apply -auto-approve) 2>&1 | tee -a $logfile
255         (cd terraform/data-storage && terraform apply -auto-approve) 2>&1 | tee -a $logfile
256         (cd terraform/services && terraform apply -auto-approve) 2>&1 | grep -v letsencrypt_iam_secret_access_key | tee -a $logfile
257         (cd terraform/services && echo -n 'letsencrypt_iam_secret_access_key = ' && terraform output letsencrypt_iam_secret_access_key) 2>&1 | tee -a $logfile
258         ;;
259
260     terraform-destroy)
261         logfile=terraform-$(date -Iseconds).log
262         (cd terraform/services && terraform destroy) 2>&1 | tee -a $logfile
263         (cd terraform/data-storage && terraform destroy) 2>&1 | tee -a $logfile
264         (cd terraform/vpc && terraform destroy) 2>&1 | tee -a $logfile
265         ;;
266
267     generate-tokens)
268         for i in BLOB_SIGNING_KEY MANAGEMENT_TOKEN SYSTEM_ROOT_TOKEN ANONYMOUS_USER_TOKEN WORKBENCH_SECRET_KEY DATABASE_PASSWORD; do
269             echo ${i}=$(tr -dc A-Za-z0-9 </dev/urandom | head -c 32 ; echo '')
270         done
271         ;;
272
273     deploy)
274         set +u
275         NODE=$1
276         set -u
277
278         checktools
279
280         loadconfig
281
282         if grep -rni 'fixme' ${CONFIG_FILE} ${CONFIG_FILE}.secrets ${CONFIG_DIR} ; then
283             echo
284             echo "Some parameters still need to be updated.  Please fix them and then re-run deploy."
285             exit 1
286         fi
287
288         BRANCH=$(git rev-parse --abbrev-ref HEAD)
289
290         set -x
291
292         git add -A
293         if ! git diff --cached --exit-code --quiet ; then
294             git commit -m"prepare for deploy"
295         fi
296
297         # Used for rolling updates to disable individual nodes at the
298         # load balancer.
299         export DISABLED_CONTROLLER=""
300         if [[ -z "$NODE" ]]; then
301             for NODE in "${!NODES[@]}"
302             do
303                 # First, just confirm we can ssh to each node.
304                 `ssh_cmd "$NODE"` $DEPLOY_USER@$NODE true
305             done
306
307             for NODE in "${!NODES[@]}"
308             do
309                 # Do 'database' role first,
310                 if [[ "${NODES[$NODE]}" =~ database ]] ; then
311                     deploynode $NODE "${NODES[$NODE]}" $BRANCH
312                     unset NODES[$NODE]
313                 fi
314             done
315
316             BALANCER=${ROLE2NODES['balancer']:-}
317
318             # Check if there are multiple controllers, they'll be comma-separated
319             # in ROLE2NODES
320             if [[ ${ROLE2NODES['controller']} =~ , ]] ;
321             then
322                 # If we have multiple controllers then there must be
323                 # load balancer. We want to do a rolling update, take
324                 # down each node at the load balancer before updating
325                 # it.
326
327                 for NODE in "${!NODES[@]}"
328                 do
329                     if [[ "${NODES[$NODE]}" =~ controller ]] ; then
330                         export DISABLED_CONTROLLER=$NODE
331
332                         # Update balancer that the node is disabled
333                         deploynode $BALANCER "${NODES[$BALANCER]}" $BRANCH
334
335                         # Now update the node itself
336                         deploynode $NODE "${NODES[$NODE]}" $BRANCH
337                         unset NODES[$NODE]
338                     fi
339                 done
340             else
341                 # Only one controller
342                 NODE=${ROLE2NODES['controller']}
343                 deploynode $NODE "${NODES[$NODE]}" $BRANCH
344                 unset NODES[$NODE]
345             fi
346
347             if [[ -n "$BALANCER" ]] ; then
348                 # Deploy balancer. In the rolling update case, this
349                 # will re-enable all the controllers at the balancer.
350                 export DISABLED_CONTROLLER=""
351                 deploynode $BALANCER "${NODES[$BALANCER]}" $BRANCH
352                 unset NODES[$BALANCER]
353             fi
354
355             for NODE in "${!NODES[@]}"
356             do
357                 # Everything else (we removed the nodes that we
358                 # already deployed from the list)
359                 deploynode $NODE "${NODES[$NODE]}" $BRANCH
360             done
361         else
362             # Just deploy the node that was supplied on the command line.
363             deploynode $NODE "${NODES[$NODE]}" $BRANCH
364         fi
365
366         set +x
367         echo
368         echo "Completed deploy, run 'installer.sh diagnostics' to verify the install"
369
370         ;;
371
372     diagnostics)
373         loadconfig
374
375         set +u
376         declare LOCATION=$1
377         set -u
378
379         if ! which arvados-client ; then
380             echo "arvados-client not found, install 'arvados-client' package with 'apt-get' or 'yum'"
381             exit 1
382         fi
383
384         if [[ -z "$LOCATION" ]] ; then
385             echo "Need to provide '-internal-client' or '-external-client'"
386             echo
387             echo "-internal-client    You are running this on the same private network as the Arvados cluster (e.g. on one of the Arvados nodes)"
388             echo "-external-client    You are running this outside the private network of the Arvados cluster (e.g. your workstation)"
389             exit 1
390         fi
391
392         export ARVADOS_API_HOST="${DOMAIN}:${CONTROLLER_EXT_SSL_PORT}"
393         export ARVADOS_API_TOKEN="$SYSTEM_ROOT_TOKEN"
394
395         arvados-client diagnostics $LOCATION
396         ;;
397
398     *)
399         echo "Arvados installer"
400         echo ""
401         echo "initialize        initialize the setup directory for configuration"
402         echo "terraform         create cloud resources using terraform"
403         echo "terraform-destroy destroy cloud resources created by terraform"
404         echo "generate-tokens   generate random values for tokens"
405         echo "deploy            deploy the configuration from the setup directory"
406         echo "diagnostics       check your install using diagnostics"
407         ;;
408 esac